package gov.usgs.earthquake.nshmp.netcdf.data;

import com.google.common.reflect.TypeToken;
import com.google.gson.Gson;

import gov.usgs.earthquake.nshmp.netcdf.NetcdfDataType;
import gov.usgs.earthquake.nshmp.netcdf.reader.NetcdfUtils.Key;

import ucar.nc2.Group;

public class ScienceBaseMetadata {

  final String catalogId;
  final NetcdfDataType dataType;
  final String description;
  final double gridStep;
  final String history;
  final String label;
  final String region;
  final ScienceBaseInfo[] scienceBaseInfo;
  final int year;

  static final Gson GSON = new Gson();

  public ScienceBaseMetadata(Group targetGroup) {
    catalogId = targetGroup.findAttribute(Key.ID).getStringValue();
    dataType = NetcdfDataType.valueOf(targetGroup.findAttribute(Key.DATA_TYPE).getStringValue());
    description = targetGroup.findAttribute(Key.DESCRIPTION).getStringValue();
    gridStep = targetGroup.findAttribute(Key.GRID_STEP).getNumericValue().doubleValue();
    history = targetGroup.findAttribute(Key.HISTORY).getStringValue();
    label = targetGroup.findAttribute(Key.LABEL).getStringValue();
    region = targetGroup.findAttribute(Key.REGION).getStringValue();
    scienceBaseInfo = GSON.fromJson(
        targetGroup.findAttribute(Key.SCIENCE_BASE_INFO).getStringValue(),
        new TypeToken<ScienceBaseInfo[]>() {}.getType());
    year = targetGroup.findAttribute(Key.YEAR).getNumericValue().intValue();
  }
}
